/*-----------------------------------------------------------------------------
	Executive file resource Susie Plug-in	Copyright (c) TORO
 ----------------------------------------------------------------------------*/
#include <windows.h>
#include "torowin.h"

#define DEBUGINFO 0
#define CopyrightSusie "Executive file resource Susie Plug-in 1.5 (c)2013-2025 TORO"

// Susie Plug-in ֘A̒` ---------------------------------------------------
// G[`
#define SUSIEERROR_NOERROR       0
#define SUSIEERROR_NOTSUPPORT   -1
#define SUSIEERROR_USERCANCEL    1
#define SUSIEERROR_UNKNOWNFORMAT 2
#define SUSIEERROR_BROKENDATA    3
#define SUSIEERROR_EMPTYMEMORY   4
#define SUSIEERROR_FAULTMEMORY   5
#define SUSIEERROR_FAULTREAD     6
#define SUSIEERROR_RESERVED      7 // Susie ł Window ֌W
#define SUSIEERROR_INTERNAL      8
#define SUSIEERROR_FILEWRITE     9 // Susie Ŏgp
#define SUSIEERROR_EOF           10 // Susie Ŏgp

// flag `
#define SUSIE_SOURCE_MASK 7
#define SUSIE_SOURCE_DISK 0
#define SUSIE_SOURCE_MEM 1
#define SUSIE_SOURCE_IGNORECASE 0x80
#define SUSIE_DEST_MASK 0x700
#define SUSIE_DEST_DISK 0
#define SUSIE_DEST_MEM 0x100
#define SUSIE_DEST_REJECT_UNKNOWN_TYPE 0x800
#define SUSIE_DEST_EXTRA_OPTION 0x1000

// ̑`
#define SUSIE_CHECK_SIZE (2 * 1024)
#define SUSIE_PATH_MAX 200

// R[obN
typedef int (__stdcall *SUSIE_PROGRESS)(int nNum, int nDenom, LONG_PTR lData);

// Susie p UNIX 
typedef ULONG_PTR susie_time_t;

// Ɋ֌W\
#pragma pack(push, 1)
typedef struct {
	unsigned char  method[8];  // k@̎
	ULONG_PTR      position;   // t@Cł̈ʒu
	ULONG_PTR      compsize;   // kꂽTCY
	ULONG_PTR      filesize;   // ̃t@CTCY
	susie_time_t   timestamp;  // t@C̍XV
	char           path[SUSIE_PATH_MAX]; // ΃pX
	char           filename[SUSIE_PATH_MAX]; // t@C
	unsigned long	crc;	// CRC
	#ifdef _WIN64
	   // 64bitł̍\̃TCY444bytesłAۂ̃TCY
	   // ACgɂ448bytesɂȂ܂BɂdummyKvłB
	   char dummy[4];
	#endif
} SUSIE_FINFO;

typedef struct {
	unsigned char  method[8]; // k@̎
	ULONG_PTR      position;  // t@Cł̈ʒu
	ULONG_PTR      compsize;  // kꂽTCY
	ULONG_PTR      filesize;  // ̃t@CTCY
	susie_time_t   timestamp; // t@C̍XV
	WCHAR          path[SUSIE_PATH_MAX]; // ΃pX
	WCHAR          filename[SUSIE_PATH_MAX]; // t@C
	unsigned long  crc; // CRC
#ifdef _WIN64
	   // 64bitł̍\̃TCY844bytesłAۂ̃TCY
	   // ACgɂ848bytesɂȂ܂BɂdummyKvłB
	char dummy[4]; // ACg
#endif
} SUSIE_FINFOW;
#pragma pack(pop)

// \[X֘A̒` ---------------------------------------------------------
#pragma pack(push,1)
// ICO/CUR t@C̃wb_
typedef struct {
	BYTE bWidth;
	BYTE bHeight;
	BYTE bColorCount;
	BYTE bReserved;
	WORD wPlanes;
	WORD wBitCount;
	DWORD dwBytesInRes;
	DWORD dwImageOffset;
} ICONDIRENTRY;

typedef struct {
	WORD idReserved;
	WORD idType;
	WORD idCount;
	ICONDIRENTRY idEntries[1];
} ICONDIR;

typedef struct {
	BYTE bWidth;
	BYTE bHeight;
	BYTE bColorCount;
	BYTE bReserved;
	WORD wPlanes;
	WORD wBitCount;
	DWORD dwBytesInRes;
	WORD ImageID;
} ICONRESDIRENTRY;

typedef struct {
	WORD idReserved;
	WORD idType;
	WORD idCount;
	ICONRESDIRENTRY idEntries[1];
} ICONRESDIR;

// NE t@C̃\[X
typedef struct {
	 WORD rnOffset;
	 WORD rnLength;
	 WORD rnFlags;
	 WORD rnID;
	 WORD rnHandle;
	 WORD rnUsage;
} NAMEINFO;

typedef struct { // ID P̏
	 WORD rtTypeID;
	 WORD rtResourceCount;
	 DWORD rtReserved;
	 NAMEINFO rtNameInfo[1]; // e\[X̏
} TYPEINFO;
#pragma pack(pop)

// ----------------------------------------------------------------------------
typedef struct {
	SUSIE_FINFOW *first, *infos, *max;
	DWORD allocsize;
	BOOL UseCache; // cache mode ׁ̈A֎~邩ǂ
} SUSIEINFOLIST;

void InitSusieInfoList(SUSIEINFOLIST &sil)
{
	sil.allocsize = 4 * sizeof(SUSIE_FINFOW);
	sil.first = (SUSIE_FINFOW *)HeapAlloc(GetProcessHeap(), 0, sil.allocsize);
	if ( sil.first == NULL ){ // mێs
		sil.infos = sil.max = NULL;
		sil.allocsize = 0;
	}else{
		sil.infos = sil.first;
		sil.max = (SUSIE_FINFOW *)(BYTE *)((BYTE *)sil.first + sil.allocsize);
	}
	sil.UseCache = FALSE;
}

SUSIE_FINFOW *CheckSizeSusieInfoList(SUSIEINFOLIST &sil)
{
	SUSIE_FINFOW *newinfos;

	if ( sil.infos < sil.max ) return sil.infos++;
	newinfos = (SUSIE_FINFOW *)HeapReAlloc(GetProcessHeap(), 0, sil.first, sil.allocsize * 2);
	if ( newinfos == NULL ) return NULL;
	sil.allocsize *= 2;
	sil.infos = newinfos + (sil.infos - sil.first);
	sil.first = newinfos;
	sil.max = (SUSIE_FINFOW *)(BYTE *)((BYTE *)newinfos + sil.allocsize);
	return sil.infos++;
}

void EndListSusieInfoList(SUSIEINFOLIST &sil)
{
	DWORD size;
	SUSIE_FINFOW *newinfos;

	if ( sil.first == NULL ) return;
	size = ((BYTE *)sil.infos - (BYTE *)sil.first) + sizeof(SUSIE_FINFOW);
	newinfos = (SUSIE_FINFOW *)HeapReAlloc(GetProcessHeap(), 0, sil.first, size);
	if ( newinfos == NULL ){
		if ( sil.infos != sil.first ) sil.infos--;
	}else{
		sil.allocsize = size;
		sil.first = newinfos;
		sil.max = (SUSIE_FINFOW *)(BYTE *)((BYTE *)sil.first + size);
		sil.infos = sil.max - 1;
	}
	sil.infos->method[0] = '\0';
	sil.infos++;
}

void FreeSusieInfoList(SUSIEINFOLIST &sil)
{
	if ( sil.first == NULL ) return;
	if ( sil.UseCache != FALSE ) return; // cache mode Ȃ̂ŉȂ
	HeapFree(GetProcessHeap(), 0, sil.first);
}

HLOCAL CopySusieInfoList(SUSIEINFOLIST &sil)
{
	HLOCAL hImage;

	if ( sil.first == NULL ) return NULL;
	hImage = LocalAlloc(0, sil.allocsize);
	if ( hImage == NULL ) return NULL;
	memcpy(LocalLock(hImage), sil.first, sil.allocsize);
	LocalUnlock(hImage);
	return hImage;
}

// ----------------------------------------------------------------------------
//HINSTANCE hDLLInst;

const WCHAR StrResIDFMT[] = L"#%05d";

#define MAX_RT_DEF 25
const WCHAR unknowntype[] = L"unknown.dat";
const WCHAR extentionname[] = L"extention.dat";
const WCHAR *resourcetypes[MAX_RT_DEF] = {
/*  0- 4 */	unknowntype, L"cur", L"bmp", L"ico",
/*  5- 7 */	L"menu.dat", L"dialog.dat", L"string.dat", L"fontdir.dat",
/*  8-11 */	L"font.dat", L"accelerator.dat", L"rcdata.dat", L"message.dat",
/* 12-15 */	L"groupcursor.cur", unknowntype, L"group.ico", unknowntype,
/* 16-19 */	L"version.dat", L"dlginclude.dat", unknowntype, L"plugplay.dat",
/* 20-23 */	L"vxd.dat", L"ANI", L"aniicon.dat", L"html",
/* 24-24 */	L"manifest.xml"
};

struct {
	SUSIEINFOLIST sil;
	WCHAR filename[MAX_PATH];
	DWORD ThreadID;
} CachedInfo = {{NULL, NULL, NULL, 0}, L"", 0};
/*-----------------------------------------------------------------------------
	dll ̏^I
-----------------------------------------------------------------------------*/
BOOL WINAPI DLLEntry(HINSTANCE, DWORD reason, LPVOID)
{
	switch (reason){
		// DLL  ---------------------------------------------------------
//		case DLL_PROCESS_ATTACH:
//			hDLLInst = hInst;
//			break;

		// DLL ̏I -----------------------------------------------------
		case DLL_PROCESS_DETACH:
			CachedInfo.sil.UseCache = FALSE;
			FreeSusieInfoList(CachedInfo.sil);
			break;
	}
	return TRUE;
}
/*-----------------------------------------------------------------------------
	Plug-in interface
-----------------------------------------------------------------------------*/
#define InfoCount 4
const char *InfoText[InfoCount] = {
	"00AM",
	CopyrightSusie,
	"*.EXE;*.DLL;*.SCR;*.SYS;*.VXD;*.ICL",
	"resource",
};

extern "C" int __stdcall GetPluginInfo(int infono, LPSTR buf, int buflen)
{
	const char *src, *srcmax;
	char *dest;

	dest = buf;
	if ( buflen > 0 ){
		if ( (DWORD)infono < (DWORD)InfoCount ){
			src = InfoText[infono];
			srcmax = src + buflen - 1;
			while( src < srcmax ){
				char code;

				code = *src++;
				if ( code == '\0' ) break;
				*dest++ = code;
			}
		}
		*dest = '\0';
	}
	return dest - buf;
}

extern "C" int __stdcall GetPluginInfoW(int infono, LPWSTR buf, int buflen)
{
	char bufA[80];
	int len;

	len = GetPluginInfo(infono, bufA, sizeof(bufA));
	if ( len <= 0 ){
		if ( buflen > 0 ) buf[0] = '\0';
		return 0;
	}
	len = AnsiToUnicode(bufA, buf, buflen);
	buf[buflen - 1] = '\0';
	return len - 1;
}
//-----------------------------------------------------------------------------
extern "C" int __stdcall IsSupportedW(LPCWSTR filename, const void *dw)
{
	BYTE buf[SUSIE_CHECK_SIZE];
	const BYTE *header;

	if ( (CachedInfo.sil.first != NULL) &&
		 (filename != NULL) &&
		 wcscmp(CachedInfo.filename, filename) ){
		FreeSusieInfoList(CachedInfo.sil);
		CachedInfo.sil.first = NULL;
	}

	if ( (DWORD_PTR)dw & ~(DWORD_PTR)0xffff ){ // 2K C[W
		header = (const BYTE *)dw;
	}else{ // t@Cnh
		DWORD size;

		buf[0] = '\0'; // t@CTCY 0 ̎A딻肵Ȃ悤ȃf[^
		if ( ReadFile((HANDLE)dw, buf, sizeof(buf), &size, NULL) == FALSE ){
			return 0; // ǂݍݎs
		}
		header = (const BYTE *)buf;
	}
	// t@Ceɂ锻
	if ( !memcmp(header, "MZ", 2) ) return 1;
	return 0;
}

extern "C" int __stdcall IsSupported(LPCSTR filename, const void *dw)
{
	WCHAR filenameW[MAX_PATH];

	AnsiToUnicode(filename, filenameW, MAX_PATH);
	filenameW[MAX_PATH - 1] = '\0'; // AnsiToUnicode  NIL ɂȂ邱Ƃ
	return IsSupportedW(NULL, dw);
}

//-----------------------------------------------------------------------------
typedef struct {
	const char *base;	// \[X̐擪
	const char *last;	// t@CC[W̖
	int offset;			// AhXp̕␳l
	SUSIEINFOLIST *sil;
	const WCHAR *typeext;	// \[X̎
	const WCHAR *name;	// \[X̖O
	int type;
} RESOURCEDIRINFO;

void SetBrokenEntry(RESOURCEDIRINFO *rdi)
{
	SUSIE_FINFOW *infos;

	if ( NULL != (infos = CheckSizeSusieInfoList(*rdi->sil)) ){
		strcpy((char *)infos->method, "memo");
		infos->position = infos->compsize = infos->filesize = 0;
		infos->timestamp = 0;
		infos->path[0] = '\0';
		wcscpy(infos->filename, L"* broken file *");
		infos->crc = 0;
	}
}

void FixResourceInfo(const char *image, DWORD sizeL, SUSIE_FINFOW *infos, int type)
{
	if ( type != 0 ){
		wsprintfA((char *)infos->method, T("Res%d"), type);
		switch ( type ){
			case RT_CURSOR: // 1
				infos->filesize += 18;
				break;

			case RT_BITMAP: // 2
				infos->filesize += 14;
				break;

			case RT_ICON: // 3
				infos->filesize += sizeof(ICONDIR);
				break;

			case RT_GROUP_CURSOR:	// 12
			case RT_GROUP_ICON: {	// 14
				// ICONRESDIR ̗LmF
				if ( (infos->position + sizeof(ICONRESDIR)) > sizeL ) break;
				const ICONRESDIR *resdir = (const ICONRESDIR *)(const char *)(image + infos->position);
				int iconcount = resdir->idCount;
				// ICONRESDIRENTRY ̗LmF
				if ( (infos->position + sizeof(ICONRESDIR) + (iconcount - 1) * sizeof(ICONRESDIRENTRY)) > sizeL ){
					break;
				}
				// ICONRESDIRENTRY eicoñTCY߂čZ
				const ICONRESDIRENTRY *irde;
				int iconsize = sizeof(ICONDIR) + (iconcount - 1) * sizeof(ICONDIRENTRY);
				for ( irde = resdir->idEntries ; iconcount > 0 ; iconcount--,irde++ ){
					iconsize += irde->dwBytesInRes;
				}
				infos->filesize = iconsize;
				break;
			}
		}
	}else{ // type == 0;
		strcpy((char *)infos->method, "Resdata");
	}
	infos->crc = 0;
	infos->path[0] = '\0';
}

void GetResourceEntryName(RESOURCEDIRINFO *rdi, IMAGE_RESOURCE_DIRECTORY_ENTRY *res_direntry, WCHAR *name)
{
	if ( res_direntry->Name & IMAGE_RESOURCE_NAME_IS_STRING ){
		const char *strptr;
		int length;

		strptr = rdi->base + (res_direntry->Name & 0x7fffffff);
		length = (int)*(WORD *)strptr;
		if ( length >= 0x200 ) length = 0x1ff;
		memcpy(name, strptr + 2, length * sizeof(WCHAR));
		name[length] = '\0';
	}else{
		wsprintfW(name, StrResIDFMT, res_direntry->Name);
	}
}

#define LEVEL_TYPEEXT 0	// \[X̎(typeext)
#define LEVEL_NAME 1	// \[X̖O(name)
void EnumResourceEntry(const char *image, DWORD sizeL, RESOURCEDIRINFO *rdi, IMAGE_RESOURCE_DIRECTORY *res_dir, int level)
{
	WCHAR name[0x200];
	IMAGE_RESOURCE_DIRECTORY_ENTRY *res_direntry;
	int dircount;
	SUSIE_FINFOW *infos;

	res_direntry = (IMAGE_RESOURCE_DIRECTORY_ENTRY *)(res_dir + 1);
#if DEBUGINFO // mFpo
	if ( NULL != (infos = CheckSizeSusieInfoList(*rdi->sil)) ){
		strcpy((char *)infos->method, "Resdir");
		infos->position = 0;
		infos->compsize = infos->filesize = 0;
		infos->timestamp = 0;
		infos->path[0] = '\0';
//		tstrcpy(infos->filename,(char *)LastSection->Name);
		if ( res_direntry->Name & IMAGE_RESOURCE_NAME_IS_STRING ){
			char *strptr;
			WCHAR namebuf[0x200];

			strptr = (char *)res_dir + (res_direntry->Name & 0x7fffffff);
			memcpy(namebuf, strptr + 2, *(WORD *)strptr * sizeof(WCHAR));
			namebuf[*(WORD *)strptr] = '\0';
			UnicodeToAnsi(namebuf, name, 0x200);
		}else{
			wsprintfA(name, StrResIDFMT, res_direntry->Name);
		}

		wsprintfW(infos->filename, L"Resdir %s %x(%d)", name, res_direntry->OffsetToData, res_direntry->OffsetToData);
		infos->crc = 0;
	}
#endif
	if ( (char *)res_direntry > rdi->last ){
		SetBrokenEntry(rdi);
		return;
	}
	dircount = res_dir->NumberOfNamedEntries + res_dir->NumberOfIdEntries;
	while( dircount ){
		if ( (char *)(res_direntry + 1) > rdi->last ){
			SetBrokenEntry(rdi);
			break;
		}

		if ( res_direntry->OffsetToData & IMAGE_RESOURCE_DATA_IS_DIRECTORY ){
			if ( level == LEVEL_TYPEEXT ){
				rdi->name = L"";
				rdi->type = 0;
				if ( res_direntry->Name & IMAGE_RESOURCE_NAME_IS_STRING ){
					GetResourceEntryName(rdi, res_direntry, name);
					rdi->typeext = name;
				}else{
					int type;

					type = res_direntry->Name;
					if ( type >= MAX_RT_DEF ) type = 0;
					rdi->typeext = resourcetypes[type];
					rdi->type = type;
				}
			}else if ( level == LEVEL_NAME ){
				GetResourceEntryName(rdi, res_direntry, name);
				rdi->name = name;
			}
			EnumResourceEntry(image, sizeL, rdi, (IMAGE_RESOURCE_DIRECTORY *)
					(rdi->base + (res_direntry->OffsetToData & 0x7fffffff)),
					level + 1 );
		}else{
			IMAGE_RESOURCE_DATA_ENTRY *res_data;

			res_data = (IMAGE_RESOURCE_DATA_ENTRY *)
					(rdi->base + res_direntry->OffsetToData);
			if ( NULL == (infos = CheckSizeSusieInfoList(*rdi->sil)) ) break;
			infos->position = res_data->OffsetToData - rdi->offset;
			infos->compsize = infos->filesize = res_data->Size;
			FixResourceInfo(image, sizeL, infos, rdi->type);
			infos->timestamp = res_dir->TimeDateStamp;
			GetResourceEntryName(rdi, res_direntry, name);
			wsprintfW(infos->filename, L"%s.%s", rdi->name, rdi->typeext);
		}
		res_direntry++;
		dircount--;
	}
	return;
}

#ifndef IMAGE_NT_OPTIONAL_HDR64_MAGIC
#define IMAGE_NT_HEADERS32 IMAGE_NT_HEADERS
#endif

void GetPEinfo(const char *image, DWORD sizeL, IMAGE_NT_HEADERS32 *xhdr, SUSIEINFOLIST &sil) // PE header(Win32/64)
{
	SUSIE_FINFOW *infos;

	{
		IMAGE_SECTION_HEADER *LastSection;
		int sections;
		DWORD resourceaddr;

		if ( xhdr->OptionalHeader.Magic != 0x20b ){	// 32bit
//#ifdef _WIN64		// \̂Ȃ悤Ȃ̂ŁA}WbNiogp
//		resourceaddr = *(DWORD *)((char *)xhdr + (24 + 144 + IMAGE_DIRECTORY_ENTRY_RESOURCE * 16));
//#else
		resourceaddr = xhdr->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_RESOURCE].VirtualAddress;
//#endif
			LastSection = IMAGE_FIRST_SECTION(xhdr);
			sections = xhdr->FileHeader.NumberOfSections;
		}else{ // 64bit;
			IMAGE_NT_HEADERS64 *xhdr64;
			xhdr64 = (IMAGE_NT_HEADERS64 *)xhdr;
			resourceaddr = xhdr64->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_RESOURCE].VirtualAddress;
			LastSection = IMAGE_FIRST_SECTION(xhdr64);
			sections = xhdr64->FileHeader.NumberOfSections;
		}

		for ( ; sections ; LastSection++,sections-- ){
#if DEBUGINFO
			if ( NULL != (infos = CheckSizeSusieInfoList(sil)) ){
				strcpy(infos->method, "Section");
				infos->position = LastSection->PointerToRawData;
				infos->compsize = infos->filesize = LastSection->SizeOfRawData;
				infos->timestamp = 0;
				infos->path[0] = '\0';
				wcscpy(infos->filename, (char *)LastSection->Name);
//				wsprintfW(infos->filename, L"%x", LastSection->PointerToRawData);
				infos->crc = 0;
			}
#endif
//			if ( wcscmp((char *)LastSection->Name, ".rsrc")) ){
			if ( LastSection->VirtualAddress == resourceaddr ){
				IMAGE_RESOURCE_DIRECTORY *res_dir;
				RESOURCEDIRINFO rdi;

				rdi.base = (image + LastSection->PointerToRawData);
				rdi.last = (image + sizeL);
				rdi.offset = LastSection->VirtualAddress - LastSection->PointerToRawData;
				rdi.typeext = L"";
				rdi.sil = &sil;
				res_dir = (IMAGE_RESOURCE_DIRECTORY *)
						(char *)(image + LastSection->PointerToRawData);
				EnumResourceEntry(image, sizeL, &rdi, res_dir, LEVEL_TYPEEXT);
			}
		}
	}
	{ // extention.dat
		IMAGE_SECTION_HEADER *LastSection;
		DWORD size;

		LastSection = IMAGE_FIRST_SECTION(xhdr) + xhdr->FileHeader.NumberOfSections - 1;
		size = LastSection->PointerToRawData + LastSection->SizeOfRawData;
		if ( (sizeL > size) &&
							// EXE1000hPʂɑĂƂ
				(sizeL != ((size + 0xfff) & 0xfffff000)) &&
							// EXE200hPʂɑĂƂ
				(sizeL != ((size + 0x1ff) & 0xfffffe00))
		){
			if ( NULL != (infos = CheckSizeSusieInfoList(sil)) ){
				strcpy((char *)infos->method, "Extent");
				infos->position = size;
				infos->compsize = infos->filesize = sizeL - size;
				infos->timestamp = 0;
				infos->path[0] = '\0';
				wcscpy(infos->filename, extentionname);
				infos->crc = 0;
			}
		}
	}
}

void GetNEinfo(const char *image, DWORD sizeL, IMAGE_NT_HEADERS32 *xhdr, SUSIEINFOLIST &sil) // NE header(Win16)
{
	WORD rscAlignShift;
	int i,idcount = 0,posmul;
	char *resourcetable;
	WCHAR namebuf[0x100];
	TYPEINFO *ti,*tip;
	NAMEINFO *ni;
	DWORD maximage = 0;
	SUSIE_FINFOW *infos;

	resourcetable = (char *)xhdr + ((IMAGE_OS2_HEADER *)xhdr)->ne_rsrctab;
	rscAlignShift = *(WORD *)resourcetable;
	posmul = 1 << rscAlignShift;
	ti = (TYPEINFO *)(resourcetable + sizeof(WORD));

	for ( tip = ti ; tip->rtTypeID ; idcount++ ){
		const WCHAR *restypename;
		int type;

		if ( tip->rtTypeID < 0x8000 ){
			TCHAR *src;
			WCHAR *dest;
			BYTE len;

			src = resourcetable + tip->rtTypeID;
			len = (BYTE)*src++;
			dest = namebuf;
			while ( len-- ) *dest++ = *src++;
			*dest ='\0';
			restypename = namebuf;
			type = 0;
		}else{
			type = tip->rtTypeID - 0x8000;
			if ( type >= MAX_RT_DEF ) type = 0;
			restypename = resourcetypes[type];
		}
#if DEBUGINFO
		if ( NULL != (infos = CheckSizeSusieInfoList(sil)) ){
			strcpy((char *)infos->method, "Section");
			infos->position = 0;
			infos->compsize = infos->filesize = 0;
			infos->timestamp = 0;
			infos->path[0] = '\0';
			wsprintfW(infos->filename, L"Section %s %x %d [%x]",
					restypename, tip->rtTypeID, tip->rtResourceCount,
					(char *)tip - (char *)xhdr + 0x90);
			infos->crc = 0;
		}
#endif
		for ( ni = tip->rtNameInfo,i = tip->rtResourceCount ; i ; ni++,i-- ){
			if ( ((char *)ni - image + sizeof(NAMEINFO)) >= sizeL ) break;
			if ( NULL != (infos = CheckSizeSusieInfoList(sil)) ){
				WCHAR idname[MAX_PATH];

				if ( ni->rnID >= 0x8000 ){
					wsprintfW(idname, StrResIDFMT, ni->rnID - 0x8000);
				}else{
					char *src;
					WCHAR *dest;
					BYTE len;

					src = resourcetable + ni->rnID;
					len = (BYTE)*src++;
					dest = idname;
					while ( len-- ) *dest++ = *src++;
					*dest ='\0';
				}

				infos->position = ni->rnOffset * posmul;
				infos->compsize = infos->filesize = ni->rnLength * posmul;
				FixResourceInfo(image, sizeL, infos, type);
				infos->timestamp = 0;
				wsprintfW(infos->filename, L"%s.%s", idname, restypename);
			}
			maximage = ni->rnOffset * posmul + ni->rnLength * posmul;
		}
		tip = (TYPEINFO *)(char *)((char *)tip + 8 + 12 * tip->rtResourceCount );
		if ( ((char *)tip - image + sizeof(TYPEINFO)) >= sizeL ) break;
	}
	if ( maximage && (maximage < sizeL) ){ // extention.dat
		if ( NULL != (infos = CheckSizeSusieInfoList(sil)) ){
			strcpy((char *)infos->method, "Extent");
			infos->position = maximage;
			infos->compsize = infos->filesize = sizeL - maximage;
			infos->timestamp = 0;
			infos->path[0] = '\0';
			wcscpy(infos->filename, extentionname);
			infos->crc = 0;
		}
	}
}

void GetMZinfo(const char *image, DWORD sizeL, SUSIEINFOLIST &sil) // MZ header(DOS)
{
	DWORD size;
	SUSIE_FINFOW *infos;

	size = (((IMAGE_DOS_HEADER *)image)->e_cp - 1) * 0x200 +
				((IMAGE_DOS_HEADER *)image)->e_cblp;
	if ( sizeL > size ){
		if ( NULL != (infos = CheckSizeSusieInfoList(sil)) ){ // extention.dat
			strcpy((char *)infos->method, "Extent");
			infos->position = size;
			infos->compsize = infos->filesize = sizeL - size;
			infos->timestamp = 0;
			infos->path[0] = '\0';
			wcscpy(infos->filename, extentionname);
			infos->crc = 0;
		}
	}
}

int __stdcall GetArchiveInfoLocal(const char *buf, LONG_PTR len, unsigned int flag, SUSIEINFOLIST &sil, BOOL unicode)
{
	HANDLE hFile;
	DWORD sizeL, sizeH;		// t@C̑傫
	char *image;
	DWORD ThreadID;
	DWORD result;
	WCHAR filenameW[MAX_PATH];;

	ThreadID = GetCurrentThreadId();
	switch ( flag & SUSIE_SOURCE_MASK ){
		case SUSIE_SOURCE_DISK:
			// LbVpt@Cp
			if ( unicode ){
				wcsncpy(filenameW, (const WCHAR *)buf, MAX_PATH);
			}else{
				AnsiToUnicode(buf, filenameW, MAX_PATH);
			}
			filenameW[MAX_PATH - 1] = '\0';

			// LbVȂ痘p
			if ( (CachedInfo.sil.first != NULL) &&
				 (CachedInfo.ThreadID == ThreadID) &&
				 !wcscmp(CachedInfo.filename, filenameW) ){
				sil = CachedInfo.sil;
				// sil.UseCache = TRUE; ł TRUE
				return SUSIEERROR_NOERROR;
			}

			// t@Cǂݍ
			if ( unicode ){
				hFile = CreateFileW((const WCHAR *)buf, GENERIC_READ,
						FILE_SHARE_WRITE | FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			}else{
				hFile = CreateFileA(buf, GENERIC_READ,
						FILE_SHARE_WRITE | FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			}
			if ( hFile == INVALID_HANDLE_VALUE ) return SUSIEERROR_FAULTREAD;
			sizeL = GetFileSize(hFile, &sizeH);
			if ( sizeH || (sizeL >= 0xffff0000) ) return SUSIEERROR_EMPTYMEMORY;

			image = (char *)HeapAlloc(GetProcessHeap(), 0, sizeL + 0x100);
			if ( image == NULL ){
				CloseHandle(hFile);
				return SUSIEERROR_EMPTYMEMORY;
			}
			if ( len != 0 ){
				LONG high;
				#ifdef _WIN64
					high = len >> 32;
				#else
					high = 0;
				#endif
				SetFilePointer(hFile, (DWORD)len, &high, FILE_BEGIN);
			}
			result = ReadFile(hFile, image, sizeL, &sizeL, NULL) ?
					NO_ERROR : GetLastError();
			CloseHandle(hFile);
			if ( (result != NO_ERROR) || (memcmp(image, "MZ", 2) != 0) ){
				HeapFree(GetProcessHeap(), 0, image);
				return SUSIEERROR_FAULTREAD;
			}
			break;

		case SUSIE_SOURCE_MEM:
			if ( (len < 0x10) || (memcmp(buf, "MZ",2) != 0) ){
				return SUSIEERROR_FAULTREAD;
			}

			image = (char *)buf; // const OĂ邪 const ̂܂
			sizeL = len;
			hFile = NULL;
			break;

		default:
			return SUSIEERROR_NOTSUPPORT;
	}

	InitSusieInfoList(sil);
	{
								// ΏOSŎʂ -------------------------
		IMAGE_NT_HEADERS32 *xhdr;
		DWORD offset;

		offset = ((const IMAGE_DOS_HEADER *)image)->e_lfanew;	// gwb_ւ̃ItZbg
		if ( offset < (sizeL - 0x180) ){
			xhdr = (IMAGE_NT_HEADERS32 *)(image + offset);
			if ( xhdr->Signature == IMAGE_NT_SIGNATURE ){ //PE header(Win32/64)
				GetPEinfo(image, sizeL, xhdr, sil);
			}else if ( ((IMAGE_OS2_HEADER *)xhdr)->ne_magic ==
					IMAGE_OS2_SIGNATURE ){	// NE header(Win/OS)
				if ( ((IMAGE_OS2_HEADER *)xhdr)->ne_exetyp == 2 ){	// Win16
					GetNEinfo(image, sizeL, xhdr, sil);
				}
			}else if ( ((IMAGE_OS2_HEADER *)xhdr)->ne_magic == 0x584c ){
															// LX header(OS2)
			}else if ( ((IMAGE_VXD_HEADER *)xhdr)->e32_magic ==
					IMAGE_VXD_SIGNATURE ){ // LE header(Win/OS)
			}else{ // DOS
				GetMZinfo(image, sizeL, sil);
			}
		}else{
			GetMZinfo(image, sizeL, sil);
		}
	}
	EndListSusieInfoList(sil);
	if ( hFile != NULL ) HeapFree(GetProcessHeap(), 0, image);

	if ( (flag & SUSIE_SOURCE_MASK) == SUSIE_SOURCE_DISK ){ // filename ̂Ƃ́ALbV
		CachedInfo.ThreadID = ThreadID;
		wcscpy(CachedInfo.filename, filenameW);
		sil.UseCache = TRUE;
		CachedInfo.sil = sil;
	}
	return SUSIEERROR_NOERROR;
}

extern "C" int __stdcall GetArchiveInfoW(LPCWSTR buf, LONG_PTR len, unsigned int flag, HLOCAL *lphInf)
{
	int result;
	SUSIEINFOLIST sil;

	result = GetArchiveInfoLocal((const char *)buf, len, flag, sil, TRUE);
	if ( result != SUSIEERROR_NOERROR ){
		*lphInf = NULL;
		return result;
	}
	*lphInf = CopySusieInfoList(sil);
	FreeSusieInfoList(sil);
	return SUSIEERROR_NOERROR;
}

extern "C" int __stdcall GetArchiveInfo(LPCSTR buf, LONG_PTR len, unsigned int flag, HLOCAL *lphInf)
{
	int result;
	SUSIEINFOLIST sil;
	HLOCAL hImage;

	result = GetArchiveInfoLocal(buf, len, flag, sil, FALSE);
	if ( result != SUSIEERROR_NOERROR ){
		*lphInf = NULL;
		return result;
	}

	if ( sil.first == NULL ){
		hImage = NULL;
	} else{ // SUSIE_FINFOW  SUSIE_FINFO ϊ
		int infocount;
		int i;
		SUSIE_FINFO *infosA;
		SUSIE_FINFOW *infosW;

		infocount = sil.allocsize / sizeof(SUSIE_FINFOW);
		hImage = LocalAlloc(0, infocount * sizeof(SUSIE_FINFO));
		if ( hImage == NULL ){
			*lphInf = NULL;
			return SUSIEERROR_EMPTYMEMORY;
		}

		infosA = (SUSIE_FINFO *)LocalLock(hImage);
		infosW = sil.first;

		for ( i = 0; i < infocount; i++ ){
			memcpy(infosA, infosW, (8 * sizeof(unsigned char)) + (sizeof(ULONG_PTR) * 3) + sizeof(susie_time_t));
			UnicodeToAnsi(infosW->path, infosA->path, SUSIE_PATH_MAX);
			infosA->path[SUSIE_PATH_MAX - 1] = '\0';
			UnicodeToAnsi(infosW->filename, infosA->filename, SUSIE_PATH_MAX);
			infosA->filename[SUSIE_PATH_MAX - 1] = '\0';
			infosA->crc = infosW->crc;
			infosA++;
			infosW++;
		}
		LocalUnlock(hImage);
	}
	*lphInf = hImage;
	return SUSIEERROR_NOERROR;
}

int __stdcall GetFileLocal(LPCSTR src, LONG_PTR len, LPSTR dest, unsigned int flag, SUSIE_PROGRESS progressCallback, LONG_PTR lData, BOOL unicode)
{
	SUSIEINFOLIST sil;
	SUSIE_FINFOW *infos;
	char *bin;
	HANDLE hFile;
	DWORD header = 0;
	HLOCAL himage = NULL;
	int result;

	// source  ̎́ASUSIEINFOLIST擾łȂ̂ŃG[ɂ
	if ( ((flag & SUSIE_DEST_MASK) > SUSIE_DEST_MEM) ||
		 ((flag & SUSIE_SOURCE_MASK) > SUSIE_SOURCE_DISK) ){
		return SUSIEERROR_NOTSUPPORT;
	}
	result = GetArchiveInfoLocal(src, len, flag, sil, unicode);
	if ( result != SUSIEERROR_NOERROR ) return result;

	if ( progressCallback != NULL ) progressCallback(0, 100, lData);
	infos = sil.first;

	while( infos->method[0] != '\0' ){
		if ( infos->position != len ){
			infos++;
			continue;
		}
		if ( !strcmp((char *)infos->method, "Res3") ){
			header = sizeof(ICONDIR);
		}else
		if ( !strcmp((char *)infos->method, "Res2") ){ // bmp
			header = 14;
		}else
		if ( !strcmp((char *)infos->method, "Res1") ){ // cursor
			header = 18;
		}

		himage = LocalAlloc(0, infos->filesize);
		if ( himage == NULL ) break;
		bin = (char *)LocalLock(himage);
/*  source ̃T|[g͂Ȃ̂Ŗ
		if ( flag & SUSIE_SOURCE_MASK ){ // source 
			if ( infos->filesize > (DWORD)len ) break;
			memcpy(bin + header,(const char *)src + infos->position,infos->compsize);
		}else
*/
		{ // source t@C
			DWORD temp;

			if ( unicode ){
				hFile = CreateFileW((const WCHAR *)src, GENERIC_READ,
						FILE_SHARE_WRITE | FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			}else{
				hFile = CreateFileA(src, GENERIC_READ,
						FILE_SHARE_WRITE | FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			}
			if ( hFile == INVALID_HANDLE_VALUE ) break;
			temp = 0;
			if ( SetFilePointer(hFile, infos->position, (PLONG)&temp, FILE_BEGIN) != 0xffffffff ){
				ReadFile(hFile, bin + header, infos->compsize, &temp, NULL);
				if ( temp != infos->compsize ) temp = 0;
			}
			CloseHandle(hFile);
			if ( temp == 0 ) break;
		}

		if ( header == sizeof(ICONDIR) ){ // RT_ICON
			((ICONDIR *)bin)->idReserved = 0;
			((ICONDIR *)bin)->idType = 1;
			((ICONDIR *)bin)->idCount = 1;

			if ( *((BYTE *)bin + sizeof(ICONDIR)) == 0x89 ){ // png
				((ICONDIR *)bin)->idEntries[0].bWidth =
						((ICONDIR *)bin)->idEntries[0].bHeight =
						((ICONDIR *)bin)->idEntries[0].bColorCount = 0;
				((ICONDIR *)bin)->idEntries[0].wBitCount = 0;
			}else{ // bmp
				BITMAPINFOHEADER *bih;

				bih = (BITMAPINFOHEADER *)(bin + sizeof(ICONDIR));
				((ICONDIR *)bin)->idEntries[0].bWidth = (BYTE)bih->biWidth;
				((ICONDIR *)bin)->idEntries[0].bHeight = (BYTE)(bih->biHeight / 2);
				((ICONDIR *)bin)->idEntries[0].bColorCount = (BYTE)(1 << bih->biBitCount);
				((ICONDIR *)bin)->idEntries[0].wBitCount = bih->biBitCount;
			}
			((ICONDIR *)bin)->idEntries[0].bReserved = 0;
			((ICONDIR *)bin)->idEntries[0].wPlanes = 0;
			((ICONDIR *)bin)->idEntries[0].dwBytesInRes = infos->compsize;
			((ICONDIR *)bin)->idEntries[0].dwImageOffset = sizeof(ICONDIR);
		}else
		if ( header == 14 ){ // RT_BITMAP
			BITMAPINFOHEADER *bmih;
			int offset, color, palette;

			bmih = (BITMAPINFOHEADER *)(bin + sizeof(BITMAPFILEHEADER));
			offset = bmih->biSize;
			color = bmih->biBitCount;
			palette = bmih->biClrUsed;
			if ( bmih->biCompression == 3 ){
				offset += 12;	// 16/32bit ̂Ƃ̓rbg蓖Ă
			}
			offset += palette ? palette * sizeof(RGBQUAD) :
					((color <= 8) ? (int)(1 << color) * sizeof(RGBQUAD) : 0);

			((BITMAPFILEHEADER *)bin)->bfType = 0x4d42; // 'BM'
			((BITMAPFILEHEADER *)bin)->bfSize = infos->filesize;
			((BITMAPFILEHEADER *)bin)->bfReserved1 = 0;
			((BITMAPFILEHEADER *)bin)->bfReserved2 = 0;
			((BITMAPFILEHEADER *)bin)->bfOffBits = sizeof(BITMAPFILEHEADER) + offset;
		}else
		if ( header == 18 ){ // RT_CURSOR
			BITMAPINFOHEADER *bih;
			int colors;
			DWORD hotspot;

			hotspot = *(DWORD *)(bin + header);

			((ICONDIR *)bin)->idReserved = 0;
			((ICONDIR *)bin)->idType = 2;
			((ICONDIR *)bin)->idCount = 1;
			bih = (BITMAPINFOHEADER *)(((ICONDIR *)bin) + 1);
			((ICONDIR *)bin)->idEntries[0].bWidth = (BYTE)bih->biWidth;
			((ICONDIR *)bin)->idEntries[0].bHeight = (BYTE)(bih->biHeight / 2);
			colors = 1 << bih->biBitCount;
			if ( colors >= 256 ) colors = 0;
			((ICONDIR *)bin)->idEntries[0].bColorCount = colors;
			((ICONDIR *)bin)->idEntries[0].wPlanes = LOWORD(hotspot); // hotx
			((ICONDIR *)bin)->idEntries[0].wBitCount = HIWORD(hotspot); //hoty
			((ICONDIR *)bin)->idEntries[0].dwBytesInRes = infos->compsize - 4;
			((ICONDIR *)bin)->idEntries[0].dwImageOffset = sizeof(ICONDIR);
		}else
		if ( !strcmp((char *)infos->method, "Res12") ||
			 !strcmp((char *)infos->method, "Res14") ){ // RT_GROUP_CURSOR(1+11),RT_GROUP_ICON(3+11)
/*  source ̃T|[g͂Ȃ̂Ŗ
			if ( flag & 0x7 ){
				FreeSusieInfoList(sil);
				return SUSIEERROR_NOTSUPPORT;
			}
*/
			HLOCAL hsingleicon;
			const WCHAR *resfmt;

			if ( infos->compsize >= infos->filesize ) break; // t@Cj
			ICONRESDIR *resdir = (ICONRESDIR *)HeapAlloc(GetProcessHeap(), 0, infos->compsize);
			if ( resdir == NULL ) break;

			memcpy(resdir, bin, infos->compsize);
			resfmt = (bin[2] == 1) ? L"#%05d.ico" : L"#%05d.cur";
			{
				int i;
				ICONRESDIRENTRY *irde;
				ICONDIRENTRY *ide;
				WCHAR resid[32];
				int destoffset;

				int iconcount = resdir->idCount;
				destoffset = sizeof(ICONDIR) + (iconcount - 1) * sizeof(ICONDIRENTRY);

				for ( i = 0, irde = resdir->idEntries, ide = ((ICONDIR *)bin)->idEntries ; i < iconcount ; i++, irde++, ide++ ){
					SUSIE_FINFOW *infos2;

					wsprintfW(resid, resfmt, irde->ImageID);
					infos2 = sil.first;
					result = SUSIEERROR_INTERNAL;
					while( infos2->method[0] != '\0' ){
						if ( wcscmp(infos2->filename, resid) != 0 ){
							infos2++;
							continue;
						}
						result = GetFileLocal(src, infos2->position, (LPSTR)&hsingleicon, (flag & 0xff) | 0x100, NULL, 0, unicode);
						break;
					}
					memcpy(ide, irde, sizeof(ICONRESDIRENTRY) - sizeof(WORD));
					ide->dwImageOffset = destoffset;
					if ( result == SUSIEERROR_NOERROR ){
						memcpy(bin + destoffset, (char *)LocalLock(hsingleicon) + sizeof(ICONDIR), irde->dwBytesInRes);
						LocalUnlock(hsingleicon);
						LocalFree(hsingleicon);
					}else{
						memset(bin + destoffset, 0, irde->dwBytesInRes);
					}
					destoffset += irde->dwBytesInRes;
				}
				infos->filesize = destoffset;
			}
			HeapFree(GetProcessHeap(), 0, resdir);
		}

		result = SUSIEERROR_NOERROR;
		if ( flag & SUSIE_DEST_MASK ){ // SUSIE_DEST_MEM
			LocalUnlock(himage);
			*(HLOCAL *)dest = himage;
		}else{ // SUSIE_DEST_DISK
			HANDLE hDestFile;

			if ( unicode ){
				WCHAR destpathW[MAX_PATH];

				wsprintfW(destpathW, L"%s\\%s", (WCHAR *)dest, infos->filename);
				hDestFile = CreateFileW(destpathW, GENERIC_WRITE, 0, NULL,
						CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
			}else{
				char filenameA[MAX_PATH];
				char destpathA[MAX_PATH];
				UnicodeToAnsi(infos->filename, filenameA, MAX_PATH);
				wsprintfA(destpathA, "%s\\%s", dest, filenameA);
				hDestFile = CreateFileA(destpathA, GENERIC_WRITE, 0, NULL,
						CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
			}
			if ( hDestFile != INVALID_HANDLE_VALUE ){
				DWORD size;

				if ( WriteFile(hDestFile, bin, infos->filesize, &size, NULL) == FALSE ){
					result = SUSIEERROR_INTERNAL;
				}
				CloseHandle(hDestFile);
			}else{
				result = SUSIEERROR_INTERNAL;
			}
			LocalUnlock(himage);
			LocalFree(himage);
		}
		FreeSusieInfoList(sil);
		if ( progressCallback != NULL ) progressCallback(100, 100, lData);
		return result;
	}
	if ( himage != NULL ){
		LocalUnlock(himage);
		LocalFree(himage);
	}
	FreeSusieInfoList(sil);
	if ( progressCallback != NULL ) progressCallback(50, 100, lData);
	return SUSIEERROR_FAULTREAD;
}

extern "C" int __stdcall GetFile(LPCSTR src, LONG_PTR len, LPSTR dest, unsigned int flag, SUSIE_PROGRESS progressCallback, LONG_PTR lData)
{
	return GetFileLocal(src, len, dest, flag, progressCallback, lData, FALSE);
}

extern "C" int __stdcall GetFileW(LPCWSTR src, LONG_PTR len, LPWSTR dest, unsigned int flag, SUSIE_PROGRESS progressCallback, LONG_PTR lData)
{
	return GetFileLocal((const char *)src, len, (char *)dest, flag, progressCallback, lData, TRUE);
}

int __stdcall GetFileInfoLocal(const char *buf, LONG_PTR len, LPCWSTR filename, unsigned int flag, SUSIE_FINFOW *lpInfo, BOOL unicode)
{
	SUSIE_FINFOW *infos;
	SUSIEINFOLIST sil;
	int result;

	result = GetArchiveInfoLocal(buf, len, flag, sil, unicode);
	if ( result != SUSIEERROR_NOERROR ) return result;

	for ( infos = sil.first ; infos->method[0] != '\0' ; infos++ ){
		#if 1 // dir Ȃ
		if ( stricmpW(infos->filename, filename) != 0 ) continue;
		#else // dir 
		if ( infos->path[0] == '\0' ){
			if ( stricmpW(infos->filename, filename) != 0 ) continue;
		}else{
			int pathlen = wcslen(infos->path);

			if ( memicmp(infos->path, filename, pathlen * sizeof(WCHAR)) != 0 ){
				continue;
			}
			while ( filename[pathlen] == '\\' ) pathlen++;
			if ( stricmpW(infos->filename, filename + pathlen) != 0 ) continue;
		}
		#endif
		*lpInfo = *infos;
		FreeSusieInfoList(sil);
		return SUSIEERROR_NOERROR;
	}
	FreeSusieInfoList(sil);
	return SUSIEERROR_NOTSUPPORT;
}

extern "C" int __stdcall GetFileInfo(LPCSTR buf, LONG_PTR len, LPCSTR filename, unsigned int flag, SUSIE_FINFO *lpInfo)
{
	WCHAR filenameW[SUSIE_PATH_MAX];
	int result;
	SUSIE_FINFOW infosW;

	AnsiToUnicode(filename, filenameW, SUSIE_PATH_MAX);
	filenameW[SUSIE_PATH_MAX - 1] = '\0';
	result = GetFileInfoLocal(buf, len, filenameW, flag, &infosW, FALSE);
	if ( result != SUSIEERROR_NOERROR ) return result;

	memcpy(lpInfo, &infosW, (8 * sizeof(unsigned char)) + (sizeof(ULONG_PTR) * 3) + sizeof(susie_time_t));
	UnicodeToAnsi(infosW.path, lpInfo->path, SUSIE_PATH_MAX);
	lpInfo->path[SUSIE_PATH_MAX - 1] = '\0';
	UnicodeToAnsi(infosW.filename, lpInfo->filename, SUSIE_PATH_MAX);
	lpInfo->filename[SUSIE_PATH_MAX - 1] = '\0';
	lpInfo->crc = infosW.crc;
	return SUSIEERROR_NOERROR;
}

extern "C" int __stdcall GetFileInfoW(LPCWSTR buf, LONG_PTR len, LPCWSTR filename, unsigned int flag, SUSIE_FINFOW *lpInfo)
{
	return GetFileInfoLocal((char *)buf, len, filename, flag, lpInfo, TRUE);
}
